VERSION 5.00
Begin VB.UserControl Sprite 
   AutoRedraw      =   -1  'True
   BackStyle       =   0  'Transparent
   ClientHeight    =   1110
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1695
   EditAtDesignTime=   -1  'True
   HitBehavior     =   2  'Use Paint
   KeyPreview      =   -1  'True
   PropertyPages   =   "pjtSprite.ctx":0000
   ScaleHeight     =   74
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   113
   ToolboxBitmap   =   "pjtSprite.ctx":002D
   Begin VB.Timer tmrNewEvents 
      Interval        =   200
      Left            =   360
      Top             =   600
   End
   Begin VB.Timer tmrKeyboard 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   1200
      Top             =   600
   End
   Begin VB.PictureBox picGraphicsEffects 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   555
      Left            =   960
      ScaleHeight     =   37
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   45
      TabIndex        =   1
      Top             =   0
      Visible         =   0   'False
      Width           =   675
   End
   Begin VB.Timer tmrAnimation 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   0
      Top             =   600
   End
   Begin VB.PictureBox PicAnimation 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   555
      Index           =   0
      Left            =   0
      ScaleHeight     =   37
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   57
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   855
      Begin VB.Shape shpSubImage 
         Height          =   255
         Index           =   0
         Left            =   0
         Top             =   0
         Width           =   435
      End
   End
   Begin VB.Timer tmrMouseStoped 
      Left            =   780
      Top             =   600
   End
End
Attribute VB_Name = "Sprite"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

Private Declare Function GetCapture Lib "user32" () As Long
Private Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function MoveToEx Lib "gdi32.dll" (ByVal hdc As Long, _
ByVal X As Long, ByVal Y As Long, lpPoint As POINT_TYPE) As Long

'Events
Event Click(MouseButton As MouseButtons, Shift As ShiftKeys, X As Long, Y As Long)
Event Collision(ObjectName As String, ObjectIndex As String, PlayerDirection As Direction)
Event ChangeImage(Subimage As Long)
Event Created(PosX As Long, PosY As Long)
Event DblClick(MouseButton As MouseButtons, Shift As ShiftKeys, X As Long, Y As Long)
Event Destroyed(PosX As Long, PosY As Long)
Event Hide(PosX As Long, PosY As Long)
Event Joystick(JoystickNumber As Long, JoystickDirection As Direction, JoystickButton As Long)
Event KeyDown(KeyCode As Integer, Shift As Integer)
Event KeyPress(KeyAscii As Integer)
Event KeyUp(KeyCode As Integer, Shift As Integer)
Event MouseDown(Button As MouseButtons, Shift As ShiftKeys, X As Single, Y As Single)
Event MouseEnter(Button As MouseButtons, Shift As ShiftKeys, X As Long, Y As Long)
Event MouseStoped(Button As MouseButtons, Shift As ShiftKeys, X As Long, Y As Long)
Event MouseExit(Button As MouseButtons, Shift As ShiftKeys, X As Long, Y As Long)
Event MouseMove(Button As MouseButtons, Shift As ShiftKeys, X As Single, Y As Single)
Event MouseUp(Button As MouseButtons, Shift As ShiftKeys, X As Single, Y As Single)
Event MouseScrolling(Scroll As MouseScroll)
Event Move(PosX As Long, PosY As Long, Direction As Direction)
Event NotMove(PosX As Long, PosY As Long, Direction As Direction)
Event Paint()
Event Resize(Width As Long, Height As Long, RTResizeType As ResizeType)
Event Show(PosX As Long, PosY As Long)

'Variables
Dim strFileName As String
Dim strMouseIcon As String
Dim blnJoystickActivate As Boolean
Dim blnActivateMoveNotMoveEvents As Boolean
Dim blnCreate As Boolean
Dim traTransparent As TransparentState
Dim blnDestroyed As Boolean
Dim blnJoystickMoveNotMove As Boolean
Dim blnEnter As Boolean
Dim blnStretch As Boolean
Dim blnTransparentImage As Boolean
Dim blnAutoSize As Boolean
Dim blnBlackAndWhite As Boolean
Dim blnTiles As Boolean
Dim blnShowImage As Boolean
Dim lngChangeImageTime As Long
Dim lngChangeActualSubImage As Long
Dim lngActualSubImage As Long
Dim lngTotalSubImages As Long
Dim lngOldPosX As Long
Dim lngOldPosY As Long
Dim lngOldWidth As Long
Dim lngOldHeight As Long
Dim lngSpriteHDC As Long
Dim lngSpriteHWND As Long
Dim lngHoverTime As Long
Dim lngOldMouseX As Long
Dim lngOldMouseY As Long
Dim lngRotate As Long
Dim lngOldColor As Long
Dim lngNewColor As Long
Dim lngTransparentColor As Long
Dim mbMouseButton As MouseButtons
Dim skShift As ShiftKeys
Dim Col As Collision
Dim Strip As Strips
Dim DirDirection As Direction
Dim MousePos As MousePosition
Dim ResizeTyp As ResizeType
Dim msScrolling As MouseScroll
Dim aniAnimation As AnimationState
Dim meMirrorEffects As MirrorStates
Dim intKeyboardKeys As Integer
Dim intKeyboardShiftKeys As Integer

'Enums
Public Enum TransparentState
    TransparentNone = 0
    TransparentAutomatic = 1
    TransparentManualy = 2
End Enum

Public Enum AnimationState
    AnimationStopped = 0
    AnimationPlay = 1
    AnimationPause = 2
End Enum

Public Enum MouseScroll
    ScrollUp = 0
    ScrollDown = 1
End Enum

Public Enum Direction
    DirectionNone = 0
    DirectionLeft = 1
    DirectionRight = 2
    DirectionUp = 3
    DirectionDown = 4
    DirectionLeftUp = 5
    DirectionLeftDown = 6
    DirectionRightUp = 7
    DirectionRightDown = 8
End Enum

Public Enum MirrorStates
    None = 0
    Vertical = 1
    Horizontal = 2
    VerticalHorizontal = 3
End Enum

Public Enum ResizeType
    ResizeVertical = 0
    ResizeHorizontal = 1
    ResizeVerticalHorizontal = 2
End Enum

Public Enum MouseButtons
    MouseButtonsNone = 0
    MouseButtonsLeft = 1
    MouseButtonsRight = 2
    MouseButtonsLeftRight = 3
    MouseButtonsMiddle = 4
End Enum

Public Enum ShiftKeys
    ShiftKeysNone = 0
    ShiftKeysShift = 1
    ShiftKeysControl = 2
    ShiftKeysShiftControl = 3
    ShiftKeysAlt = 4
    ShiftKeysAltShift = 5
    ShiftKeysAltControl = 6
End Enum

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type POINT_TYPE
    X As Long
    Y As Long
End Type

Private Type Msg
    hWnd As Long
    Message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

Private Type Strips
    Activate As Boolean
    ImagesLine As Long
    ImagesColumn As Long
    Left As Long
    Top As Long
    Height As Long
    Width As Long
    SeparationVertical As Long
    SeparationHorizontal As Long
End Type

Private Type Collision
    Activate As Boolean
    Left As Long
    Top As Long
    Height As Long
    Width As Long
End Type

Private Type MousePosition
    X As Long
    Y As Long
End Type

Const lBF = &H800000


Private Sub tmrKeyboard_Timer()
    If intKeyboardKeys <> -1 Or intKeyboardShiftKeys <> -1 Then
        RaiseEvent KeyDown(intKeyboardKeys, intKeyboardShiftKeys)
    Else
        tmrKeyboard.Enabled = False
    End If
End Sub

Private Sub tmrMouseStoped_Timer()
    If blnDestroyed = True Then
        tmrMouseStoped.Enabled = False
        Exit Sub
    End If
    'For test and simulate the mouse Stopped
    If MousePos.X = lngOldMouseX And MousePos.Y = lngOldMouseY And blnEnter = False Then
        RaiseEvent MouseStoped(mbMouseButton, skShift, MousePos.X, MousePos.Y)
    Else
        lngOldMouseX = MousePos.X
        lngOldMouseY = MousePos.Y
    End If
End Sub

Private Sub tmrNewEvents_Timer()
    Dim i As Integer
    Dim RealName As String
    Dim Name As String
    Dim ctlTemp As Control
    Dim L1 As Long
    Dim L2 As Long
    Dim T1 As Long
    Dim T2 As Long
    Dim H1 As Long
    Dim H2 As Long
    Dim W1 As Long
    Dim W2 As Long
    If Ambient.UserMode = False Then
        tmrNewEvents.Enabled = False
        Exit Sub
    End If
    If blnCreate = False Then
        lngOldPosX = Extender.Left
        lngOldPosY = Extender.Top
        Hook2 UserControl.ParentControls(0).hWnd
        RaiseEvent Created(lngOldPosX, lngOldPosY)
        blnCreate = True
    End If
    Dim Direction As Direction
    If (blnActivateMoveNotMoveEvents = False And blnJoystickActivate = False) Then tmrNewEvents.Enabled = False
    If blnActivateMoveNotMoveEvents = True Then
        If (lngOldPosX < Extender.Left And lngOldPosY < Extender.Top) Then
            DirDirection = DirectionRightDown
        ElseIf (lngOldPosX < Extender.Left And lngOldPosY > Extender.Top) Then
            DirDirection = DirectionRightUp
        ElseIf (lngOldPosX > Extender.Left And lngOldPosY < Extender.Top) Then
            DirDirection = DirectionLeftDown
        ElseIf (lngOldPosX > Extender.Left And lngOldPosY > Extender.Top) Then
            DirDirection = DirectionLeftUp
        ElseIf (lngOldPosX > Extender.Left) Then
            DirDirection = DirectionLeft
        ElseIf (lngOldPosX < Extender.Left) Then
            DirDirection = DirectionRight
        ElseIf (lngOldPosY > Extender.Top) Then
            DirDirection = DirectionUp
        ElseIf (lngOldPosY < Extender.Top) Then
            DirDirection = DirectionDown
        End If
        If Extender.Left <> lngOldPosX Or Extender.Top <> lngOldPosY Then
            lngOldPosX = Extender.Left
            lngOldPosY = Extender.Top
            RaiseEvent Move(lngOldPosX, lngOldPosY, DirDirection)
            DoEvents
            Name = Extender.Name
            If Col.Activate = True Then
                L1 = Extender.Left + Col.Left
                T1 = Extender.Top + Col.Top
                W1 = Col.Width
                H1 = Col.Height
            Else
                L1 = lngOldPosX
                T1 = lngOldPosY
                W1 = Extender.Width
                H1 = Extender.Height
            End If
            For i = 0 To UserControl.Parent.Controls.Count - 1
                If UserControl.Parent.Controls(i).Name <> Name Then
                    If TypeName(UserControl.Parent.Controls(i)) = "Sprite" Then
                        If UserControl.Parent.Controls(i).LimColActivate = True Then
                            L2 = UserControl.Parent.Controls(i).Left + UserControl.Parent.Controls(i).LimColLeft
                            T2 = UserControl.Parent.Controls(i).Top + UserControl.Parent.Controls(i).LimColTop
                            W2 = UserControl.Parent.Controls(i).LimColWidth
                            H2 = UserControl.Parent.Controls(i).LimColHeight
                        Else
                            L2 = UserControl.Parent.Controls(i).Left
                            T2 = UserControl.Parent.Controls(i).Top
                            W2 = UserControl.Parent.Controls(i).Width
                            H2 = UserControl.Parent.Controls(i).Height
                        End If
                        If CollisionPrecise(L1, T1, W1, H1, L2, T2, W2, H2) = True Then
                            RaiseEvent Collision(UserControl.Parent.Controls(i).Name, IndexControlArray(UserControl.Parent.Controls(i)), DirDirection)
                            Exit For
                        End If
                    Else
                        L2 = UserControl.Parent.Controls(i).Left
                        T2 = UserControl.Parent.Controls(i).Top
                        W2 = UserControl.Parent.Controls(i).Width
                        H2 = UserControl.Parent.Controls(i).Height
                        If CollisionPrecise(L1, T1, W1, H1, L2, T2, W2, H2) = True Then
                            RaiseEvent Collision(UserControl.Parent.Controls(i).Name, IndexControlArray(UserControl.Parent.Controls(i)), DirDirection)
                            Exit For
                        End If
                    End If
                End If
            Next i
        Else
            RaiseEvent NotMove(lngOldPosX, lngOldPosY, DirDirection)
        End If
    End If
    If (blnJoystickActivate = True And StartJoystick(0) = True) Then
        Call PollJoystick
        If (MYJOYEX.dwXpos = 0 And MYJOYEX.dwYpos = 0) Then
            Direction = DirectionLeftUp
        ElseIf (MYJOYEX.dwXpos = 0 And MYJOYEX.dwYpos = 65535) Then
            Direction = DirectionLeftDown
        ElseIf (MYJOYEX.dwXpos = 65535 And MYJOYEX.dwYpos = 0) Then
            Direction = DirectionRightUp
        ElseIf (MYJOYEX.dwXpos = 65535 And MYJOYEX.dwYpos = 65535) Then
            Direction = DirectionRightDown
        ElseIf (MYJOYEX.dwXpos = 0) Then
            Direction = DirectionLeft
        ElseIf (MYJOYEX.dwXpos = 65535) Then
            Direction = DirectionRight
        ElseIf (MYJOYEX.dwYpos = 0) Then
            Direction = DirectionUp
        ElseIf (MYJOYEX.dwYpos = 65535) Then
            Direction = DirectionDown
        Else
            Direction = DirectionNone
        End If
        RaiseEvent Joystick(JoyNum, Direction, lngButton)
    End If
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click(mbMouseButton, skShift, MousePos.X, MousePos.Y)
End Sub

Private Sub UserControl_DblClick()
    If blnDestroyed = True Then Exit Sub
    RaiseEvent DblClick(mbMouseButton, skShift, MousePos.X, MousePos.Y)
End Sub

Private Sub UserControl_Hide()
    RaiseEvent Hide(lngOldPosX, lngOldPosY)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If blnDestroyed = True Then Exit Sub
    RaiseEvent MouseDown(mbMouseButton, skShift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    MousePos.X = X
    MousePos.Y = Y
    mbMouseButton = Button
    skShift = Shift
    With UserControl
        If GetCapture <> .hWnd Then SetCapture .hWnd
        If ((X < 0 Or Y < 0 Or X > .ScaleWidth Or Y > .ScaleHeight) Or IIf(traTransparent = TransparentAutomatic Or traTransparent = TransparentManualy, GetPixel(UserControl.hdc, MousePos.X, MousePos.Y) = UserControl.BackColor, GetPixel(UserControl.hdc, MousePos.X, MousePos.Y) = -1)) Then  ' we're off the form
            ReleaseCapture
            blnEnter = True
            MouseOverControl = 0
            RaiseEvent MouseExit(mbMouseButton, skShift, MousePos.X, MousePos.Y)
        Else
            If blnEnter = True Then
                blnEnter = False
                lngOldMouseX = MousePos.X
                lngOldMouseY = MousePos.Y
                MouseOverControl = UserControl.hWnd
                RaiseEvent MouseEnter(mbMouseButton, skShift, MousePos.X, MousePos.Y)
            End If
        End If
    End With
    RaiseEvent MouseMove(mbMouseButton, skShift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If blnDestroyed = True Then Exit Sub
    RaiseEvent MouseUp(mbMouseButton, skShift, X, Y)
End Sub

Public Property Get HoverTime() As Long
Attribute HoverTime.VB_Description = "Time that you can stop the mouse in a control."
Attribute HoverTime.VB_ProcData.VB_Invoke_Property = "General"
    If blnDestroyed = True Then lngHoverTime = -1
    HoverTime = lngHoverTime
End Property

Public Property Let HoverTime(newHoverTime As Long)
    If blnDestroyed = True Then Exit Property
    If newHoverTime < 0 Then Exit Property
    lngHoverTime = newHoverTime
    tmrMouseStoped.Interval = lngHoverTime
    tmrMouseStoped.Enabled = Ambient.UserMode
    PropertyChanged "HoverTime"
End Property

Private Sub tmrAnimation_Timer()
    If Animation = AnimationPause Or Animation = AnimationStopped Then
        tmrAnimation.Enabled = False
        Exit Sub
    End If
    If lngActualSubImage < PicAnimation.Count - 1 Then
        lngActualSubImage = lngActualSubImage + 1
    Else
        If Strip.Activate = True Then
            lngActualSubImage = 1
        Else
            lngActualSubImage = 0
        End If
    End If
    Call ShowImage
End Sub

Private Sub UserControl_Initialize()
    blnCreate = False
    blnActivateMoveNotMoveEvents = True
    blnJoystickActivate = True
    blnAutoSize = True
    blnBlackAndWhite = False
    blnTiles = False
    traTransparent = TransparentAutomatic
    blnDestroyed = False
    blnEnter = True
    DirDirection = DirectionLeft
    Col.Activate = False
    Col.Height = UserControl.Height
    Col.Width = UserControl.Width
    Col.Left = 0
    Col.Top = 0
    Strip.Activate = False
    Strip.Height = 0
    Strip.ImagesColumn = 0
    Strip.ImagesLine = 0
    Strip.Left = 0
    Strip.SeparationHorizontal = 0
    Strip.SeparationVertical = 0
    Strip.Top = 0
    Strip.Width = 0
    lngChangeImageTime = 1000
    lngChangeActualSubImage = 0
    lngTotalSubImages = 0
    lngOldWidth = UserControl.Width
    lngOldHeight = UserControl.Height
    lngOldMouseX = 0
    lngOldMouseY = 0
    lngHoverTime = 100
    lngRotate = 0
    mbMouseButton = 0
    blnJoystickMoveNotMove = True
    aniAnimation = AnimationStopped
    blnStretch = False
    lngTransparentColor = UserControl.BackColor
    blnTransparentImage = False
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
        
    If KeyCode = 1000 Then
        msScrolling = ScrollUp
        If blnEnter = False Then RaiseEvent MouseScrolling(msScrolling)
    ElseIf KeyCode = 1001 Then
        msScrolling = ScrollDown
        If blnEnter = False Then RaiseEvent MouseScrolling(msScrolling)
    Else
        intKeyboardKeys = KeyCode
        intKeyboardShiftKeys = Shift
        If tmrKeyboard.Enabled = False Then tmrKeyboard.Enabled = True
    End If
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
    intKeyboardKeys = -1
    intKeyboardShiftKeys = -1
End Sub

Private Sub UserControl_Paint()
     RaiseEvent Paint
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    FileName = PropBag.ReadProperty("FileName", "")
    MouseIcon = PropBag.ReadProperty("MouseIcon", "")
    ChangeImageTime = PropBag.ReadProperty("ChangeImageTime", 100)
    HoverTime = PropBag.ReadProperty("HoverTime", 100)
    Col.Height = PropBag.ReadProperty("LimColHeight", 0)
    Col.Left = PropBag.ReadProperty("LimColLeft", 0)
    Col.Top = PropBag.ReadProperty("LimColTop", 0)
    Col.Width = PropBag.ReadProperty("LimColWidth", 0)
    LimColActivate = PropBag.ReadProperty("LimColActivate", False)
    Strip.Height = PropBag.ReadProperty("StripsHeight", 0)
    Strip.ImagesColumn = PropBag.ReadProperty("StripsImagesColumn", 0)
    Strip.ImagesLine = PropBag.ReadProperty("StripsImagesLine", 0)
    Strip.Left = PropBag.ReadProperty("StripsLeft", 0)
    Strip.SeparationHorizontal = PropBag.ReadProperty("StripsSeparationHorizontal", 0)
    Strip.SeparationVertical = PropBag.ReadProperty("StripsSeparationVertical", 0)
    Strip.Top = PropBag.ReadProperty("StripsTop", 0)
    Strip.Width = PropBag.ReadProperty("StripsWidth", 0)
    StripsActivate = PropBag.ReadProperty("StripsActivate", False)
    ActivateMoveNotMoveEvents = PropBag.ReadProperty("ActivateMoveNotMoveEvents", True)
    ActivateJoystick = PropBag.ReadProperty("ActivateJoystick", True)
    Transparent = PropBag.ReadProperty("Transparent", TransparentAutomatic)
    TransparentColor = PropBag.ReadProperty("TransparentColor", UserControl.BackColor)
    Animation = PropBag.ReadProperty("Animation", AnimationStopped)
    Mirror = PropBag.ReadProperty("Mirror", 0)
    Stretch = PropBag.ReadProperty("Stretch", False)
    TransparentImage = PropBag.ReadProperty("TransparentImage", False)
    AutoSize = PropBag.ReadProperty("AutoSize", True)
    Rotate = PropBag.ReadProperty("Rotate", 0)
    BlackAndWhite = PropBag.ReadProperty("BlackAndWhite", False)
    AutoRedraw = PropBag.ReadProperty("AutoRedraw", True)
    Tiles = PropBag.ReadProperty("Tiles", False)
    OldColor = PropBag.ReadProperty("OldColor", vbBlack)
    NewColor = PropBag.ReadProperty("NewColor", vbBlack)
End Sub

Private Sub UserControl_Resize()
    If UserControl.hWnd = 0 Then Exit Sub
    If blnAutoSize = False Then
        picGraphicsEffects.Width = UserControl.ScaleWidth
        picGraphicsEffects.Height = UserControl.ScaleHeight
    End If
    Call ShowImage
    If (UserControl.Width <> lngOldWidth And UserControl.Height <> lngOldHeight) Then
        ResizeTyp = ResizeVerticalHorizontal
    ElseIf UserControl.Width <> lngOldWidth Then
        ResizeTyp = ResizeHorizontal
    ElseIf UserControl.Height <> lngOldHeight Then
        ResizeTyp = ResizeVertical
    End If
    lngOldWidth = UserControl.Width
    lngOldHeight = UserControl.Height
    If strFileName = Empty Then Call SubTransparent
    RaiseEvent Resize(UserControl.Width, UserControl.Height, ResizeTyp)
End Sub

Private Sub UserControl_Show()
     RaiseEvent Show(lngOldPosX, lngOldPosY)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "FileName", FileName, ""
    PropBag.WriteProperty "MouseIcon", MouseIcon, ""
    PropBag.WriteProperty "LimColHeight", Col.Height, 0
    PropBag.WriteProperty "LimColWidth", Col.Width, 0
    PropBag.WriteProperty "LimColTop", Col.Top, 0
    PropBag.WriteProperty "LimColLeft", Col.Left, 0
    PropBag.WriteProperty "LimColActivate", LimColActivate, False
    PropBag.WriteProperty "ChangeImageTime", ChangeImageTime, 100
    PropBag.WriteProperty "HoverTime", HoverTime, 100
    PropBag.WriteProperty "StripsHeight", Strip.Height, 0
    PropBag.WriteProperty "StripsImagesColumn", Strip.ImagesColumn, 0
    PropBag.WriteProperty "StripsImagesLine", Strip.ImagesLine, 0
    PropBag.WriteProperty "StripsLeft", Strip.Left, 0
    PropBag.WriteProperty "StripsSeparationHorizontal", Strip.SeparationHorizontal, 0
    PropBag.WriteProperty "StripsSeparationVertical", Strip.SeparationVertical, 0
    PropBag.WriteProperty "StripsTop", Strip.Top, 0
    PropBag.WriteProperty "StripsWidth", Strip.Width, 0
    PropBag.WriteProperty "StripsActivate", StripsActivate, False
    PropBag.WriteProperty "ActivateMoveNotMoveEvents", ActivateMoveNotMoveEvents, True
    PropBag.WriteProperty "ActivateJoystick", ActivateJoystick, True
    PropBag.WriteProperty "TotalSubImage", lngTotalSubImages, 1
    PropBag.WriteProperty "Transparent", Transparent, TransparentAutomatic
    PropBag.WriteProperty "TransparentColor", TransparentColor, UserControl.BackColor
    PropBag.WriteProperty "Animation", Animation, AnimationStopped
    PropBag.WriteProperty "Mirror", Mirror, 0
    PropBag.WriteProperty "Stretch", Stretch, False
    PropBag.WriteProperty "TransparentImage", TransparentImage, False
    PropBag.WriteProperty "AutoSize", AutoSize, True
    PropBag.WriteProperty "Rotate", Rotate, 0
    PropBag.WriteProperty "AutoRedraw", AutoRedraw, 0
    PropBag.WriteProperty "BlackAndWhite", BlackAndWhite, False
    PropBag.WriteProperty "Tiles", Tiles, False
    PropBag.WriteProperty "OldColor", OldColor, vbBlack
    PropBag.WriteProperty "NewColor", NewColor, vbBlack
End Sub

Private Sub UserControl_Terminate()
    Dim pt As POINT_TYPE
    Dim i As Integer
    On Error Resume Next
    RaiseEvent Destroyed(lngOldPosX, lngOldPosY)
    tmrNewEvents.Enabled = False
    tmrAnimation.Enabled = False
    tmrMouseStoped.Enabled = False
    tmrKeyboard.Enabled = False
    Unhook2 UserControl.ParentControls(0).hWnd
    MouseOverControl = 0
    If PicAnimation.Count > 1 Then
        For i = 1 To PicAnimation.Count - 1
            Unload PicAnimation(i)
            If shpSubImage.Count > 1 Then
                Unload shpSubImage(i)
            End If
        Next i
    End If
    UserControl.Cls
    Set UserControl.MaskPicture = Nothing
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=11,0,0,
Public Property Get FileName() As String
Attribute FileName.VB_Description = "Change the actual image."
Attribute FileName.VB_ProcData.VB_Invoke_Property = "General"
    If blnDestroyed = True Then strFileName = ""
    FileName = strFileName
End Property

Public Property Let FileName(New_FileName As String)
    Dim i As Integer
    On Error Resume Next
    strFileName = New_FileName
    tmrAnimation.Enabled = False
    If (Dir(strFileName) = "" Or ValidFile(UCase(strFileName)) = False) Then
        UserControl.Picture = Nothing
        UserControl.MaskPicture = Nothing
        UserControl.MaskColor = vbBlack
        UserControl.Cls
        Strip.Activate = False
        StripsActivate = Strip.Activate
        lngActualSubImage = 0
        lngTotalSubImages = 0
        aniAnimation = AnimationStopped
        Exit Property
    End If
    If strFileName Like "*:\*" = False Then strFileName = App.Path & New_FileName
    If PicAnimation.Count > 1 Then
        For i = 1 To PicAnimation.Count - 1
            Unload PicAnimation(i)
            If shpSubImage.Count > 1 Then
                Unload shpSubImage(i)
            End If
        Next i
    End If
    
    If (UCase(strFileName) Like "*.GIF") Then
        Call LoadGif(strFileName, PicAnimation)
    ElseIf (UCase(strFileName) Like "*.ANI") Or (UCase(strFileName) Like "*.CUR") Then
        Call AnimatedCursor(strFileName, PicAnimation)
    Else
        PicAnimation(0).Picture = LoadPicture(strFileName)
    End If
    
    lngChangeImageTime = PicAnimation(0).Tag
    lngActualSubImage = IFF(Strip.Activate = True, 1, 0)
    lngTotalSubImages = IFF(Strip.Activate = True, PicAnimation.Count - 1, PicAnimation.Count)
    If blnAutoSize = True Then
        UserControl.Width = PicAnimation(lngActualSubImage).ScaleWidth * Screen.TwipsPerPixelX
        UserControl.Height = PicAnimation(lngActualSubImage).ScaleHeight * Screen.TwipsPerPixelY
    End If
    UserControl.Picture = PicAnimation(lngActualSubImage).Image
    UserControl.BackColor = PicAnimation(lngActualSubImage).BackColor
    
    If lngTotalSubImages > 1 Then
        Animation = AnimationPlay
        tmrAnimation.Interval = lngChangeImageTime
        tmrAnimation.Enabled = Ambient.UserMode
    End If
    
    Col.Height = Extender.Height
    Col.Left = Extender.Left
    Col.Top = Extender.Top
    Col.Width = Extender.Width
    If StripsActivate = True Then Call UpgradeSubimages
    PicAnimation(0).Tag = ""
    Call ShowImage
    PropertyChanged "FileName"
End Property

Public Property Get MouseIcon() As String
Attribute MouseIcon.VB_Description = "Change the mouse icon."
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = "General"
    If blnDestroyed = True Then strMouseIcon = ""
    MouseIcon = strMouseIcon
End Property

Public Property Let MouseIcon(ByVal vNewValue As String)
    If blnDestroyed = True Then Exit Property
    Dim strExtensao As String
    strMouseIcon = UCase(vNewValue)
    If ValidMouse(strMouseIcon) = False Then Exit Property
    UserControl.MousePointer = 99
    UserControl.MouseIcon = LoadPicture(strMouseIcon)
    PropertyChanged "MouseIcon"
End Property

Public Property Get LimColActivate() As Boolean
Attribute LimColActivate.VB_Description = "Is for activate or desactivate the collision precise."
Attribute LimColActivate.VB_ProcData.VB_Invoke_Property = "Colision"
    If blnDestroyed = True Then Col.Activate = False
    LimColActivate = Col.Activate
End Property

Public Property Let LimColActivate(ByVal vNewValue As Boolean)
    If blnDestroyed = True Then Exit Property
    Col.Activate = vNewValue
    PropertyChanged "LimColActivate"
End Property

Public Property Get LimColTop() As Long
Attribute LimColTop.VB_Description = "Change the top position of the collision precision rectangule."
Attribute LimColTop.VB_ProcData.VB_Invoke_Property = "Colision"
    If blnDestroyed = True Then Col.Top = -1
    LimColTop = Col.Top
End Property

Public Property Let LimColTop(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Col.Top = vNewValue
    PropertyChanged "LimColtop"
End Property

Public Property Get LimColLeft() As Long
Attribute LimColLeft.VB_Description = "Change the actual left position of collision precision rectangule."
Attribute LimColLeft.VB_ProcData.VB_Invoke_Property = "Colision"
    If blnDestroyed = True Then Col.Left = -1
    LimColLeft = Col.Left
End Property

Public Property Let LimColLeft(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Col.Left = vNewValue
    PropertyChanged "LimColLeft"
End Property

Public Property Get LimColHeight() As Long
Attribute LimColHeight.VB_Description = "For change the height of the collision precision rectangule."
Attribute LimColHeight.VB_ProcData.VB_Invoke_Property = "Colision"
    If blnDestroyed = True Then Col.Height = -1
    LimColHeight = Col.Height
End Property

Public Property Let LimColHeight(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Col.Height = vNewValue
    PropertyChanged "LimColHeight"
End Property

Public Property Get LimColWidth() As Long
Attribute LimColWidth.VB_Description = "Chnage the width of the collision precision rectangule."
Attribute LimColWidth.VB_ProcData.VB_Invoke_Property = "Colision"
    If blnDestroyed = True Then Col.Width = -1
    LimColWidth = Col.Width
End Property

Public Property Let LimColWidth(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Col.Width = vNewValue
    PropertyChanged "LimColWidth"
End Property

Public Property Get TransparentColor() As OLE_COLOR
Attribute TransparentColor.VB_Description = "For change the transparent color. The Transparent property must be Manualy"
    TransparentColor = lngTransparentColor
End Property

Public Property Let TransparentColor(ByVal vNewValue As OLE_COLOR)
    lngTransparentColor = vNewValue
    Call ShowImage
    PropertyChanged "TransparentColor"
End Property

Public Property Get Animation() As AnimationState
Attribute Animation.VB_Description = "Is for stop, play, or pause the animation."
    Animation = aniAnimation
End Property

Public Property Let Animation(ByVal vNewValue As AnimationState)
    aniAnimation = vNewValue
    If ((aniAnimation = AnimationPlay And lngTotalSubImages < 2) Or aniAnimation = AnimationStopped) Then
        aniAnimation = 0
        tmrAnimation.Enabled = False
        If Strip.Activate = False Then
            lngActualSubImage = 0
        Else
            lngActualSubImage = 1
        End If
    ElseIf aniAnimation = AnimationPause Then
        tmrAnimation.Enabled = False
    ElseIf (aniAnimation = AnimationPlay And lngTotalSubImages > 1) Then
        tmrAnimation.Enabled = Ambient.UserMode
    End If
    Call ShowImage
    PropertyChanged "Animation"
End Property

Public Property Get ChangeImageTime() As Long
Attribute ChangeImageTime.VB_Description = "Change the time of animation."
    If blnDestroyed = True Then lngChangeImageTime = -1
    ChangeImageTime = lngChangeImageTime
End Property

Public Property Let ChangeImageTime(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    lngChangeImageTime = vNewValue
    tmrAnimation.Interval = lngChangeImageTime
    PropertyChanged "ChangeImageTime"
End Property

Public Property Get TotalSubImage() As Long
Attribute TotalSubImage.VB_Description = "Number of SubImages."
    If blnDestroyed = True Then lngTotalSubImages = -1
    TotalSubImage = lngTotalSubImages
End Property

Public Property Let TotalSubImage(ByVal vNewValue As Long)
    PropertyChanged "TotalSubImage"
End Property

Public Property Get ActualSubImage() As Long
Attribute ActualSubImage.VB_Description = "Change the actual subimage in an animation."
    ActualSubImage = lngActualSubImage
End Property

Public Property Let ActualSubImage(ByVal vNewValue As Long)
    If vNewValue < 0 Then
        vNewValue = 0
    ElseIf vNewValue > lngTotalSubImages - 1 Then
        vNewValue = lngTotalSubImages - 1
    End If
    lngActualSubImage = vNewValue
    Call ShowImage
End Property

Public Sub Destroy()
    If blnDestroyed = True Then Exit Sub
    RaiseEvent Destroyed(lngOldPosX, lngOldPosY)
    blnDestroyed = True
    Call UserControl_Terminate
End Sub

Public Function JoystickDetect(NumberJoystick As Long) As Boolean
    If blnDestroyed = True Then Exit Function
    JoystickDetect = StartJoystick(NumberJoystick)
End Function

Public Function DetectSelectedKey(Key As Long) As Boolean
    If blnDestroyed = True Then Exit Function
    If GetKeyState(Key) < 0 Then
        DetectSelectedKey = True
    Else
        DetectSelectedKey = False
    End If
End Function

Private Sub SubTransparent()
    On Error Resume Next
    If PicAnimation(0).Tag = "" Then
        UserControl.BackStyle = 0
        If traTransparent = TransparentAutomatic Then
            If strFileName <> "" Then
                If GetPixel(UserControl.hdc, 0, 0) <> UserControl.BackColor Then UserControl.BackColor = GetPixel(UserControl.hdc, 0, 0)
                If (UCase(strFileName) Like "*.ANI") Or (UCase(strFileName) Like "*.CUR") Then UserControl.BackColor = GetPixel(UserControl.hdc, BmpInfo.bmWidth, BmpInfo.bmHeight)
                lngTransparentColor = UserControl.BackColor
                UserControl.MaskColor = UserControl.BackColor
                UserControl.MaskPicture = UserControl.Image
                PicAnimation(0).Tag = "1"
            Else
                lngTransparentColor = GetPixel(UserControl.hdc, 0, 0)
                UserControl.MaskColor = UserControl.BackColor
                UserControl.MaskPicture = UserControl.Image
                PicAnimation(0).Tag = "1"
            End If
            
        ElseIf traTransparent = TransparentManualy Then
            UserControl.MaskColor = lngTransparentColor
            UserControl.MaskPicture = UserControl.Image
            PicAnimation(0).Tag = "1"
        End If
    Else
        If traTransparent = TransparentAutomatic Then
            lngTransparentColor = GetPixel(UserControl.hdc, 0, 0)
            UserControl.MaskColor = lngTransparentColor
            UserControl.MaskPicture = UserControl.Image
        ElseIf traTransparent = TransparentManualy Then
            UserControl.MaskColor = lngTransparentColor
            UserControl.MaskPicture = UserControl.Image
        End If
    End If
    If traTransparent = TransparentNone Then
        UserControl.BackStyle = 1
        UserControl.MaskPicture = UserControl.Image
    End If
End Sub

Public Property Get StripsActivate() As Boolean
Attribute StripsActivate.VB_Description = "Activate or desactivate the strips animation."
Attribute StripsActivate.VB_ProcData.VB_Invoke_Property = "Strips"
    If blnDestroyed = True Then Strip.Activate = False
    StripsActivate = Strip.Activate
End Property

Public Property Let StripsActivate(ByVal vNewValue As Boolean)
    If blnDestroyed = True Then Exit Property
    Strip.Activate = vNewValue
    If Strip.Activate = True Then
        lngActualSubImage = 1
        lngTotalSubImages = Strip.ImagesColumn * Strip.ImagesLine
        Call UpgradeSubimages
        tmrAnimation.Enabled = True
        tmrAnimation.Enabled = Ambient.UserMode
    Else
        tmrAnimation.Enabled = False
        lngActualSubImage = 0
    End If
    PropertyChanged "StripsActivate"
End Property

Public Property Get StripsImagesLine() As Long
Attribute StripsImagesLine.VB_Description = "Change the number of images by line in strip."
Attribute StripsImagesLine.VB_ProcData.VB_Invoke_Property = "Strips"
    If blnDestroyed = True Then Strip.ImagesLine = -1
    StripsImagesLine = Strip.ImagesLine
End Property

Public Property Let StripsImagesLine(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Strip.ImagesLine = vNewValue
    PropertyChanged "StripsImageLine"
End Property

Public Property Get StripsImagesColumn() As Long
Attribute StripsImagesColumn.VB_Description = "Change the number of images by column in a strip."
Attribute StripsImagesColumn.VB_ProcData.VB_Invoke_Property = "Strips"
    If blnDestroyed = True Then Strip.ImagesColumn = -1
    StripsImagesColumn = Strip.ImagesColumn
End Property

Public Property Let StripsImagesColumn(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Strip.ImagesColumn = vNewValue
    PropertyChanged "StripsImagesColumn"
End Property

Public Property Get StripsLeft() As Long
Attribute StripsLeft.VB_Description = "Change the left position of strip retangule."
Attribute StripsLeft.VB_ProcData.VB_Invoke_Property = "Strips"
    If blnDestroyed = True Then Strip.Left = -1
    StripsLeft = Strip.Left
End Property

Public Property Let StripsLeft(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Strip.Left = vNewValue
    PropertyChanged "StripsLeft"
End Property

Public Property Get StripsTop() As Long
Attribute StripsTop.VB_Description = "Change the strip top position."
Attribute StripsTop.VB_ProcData.VB_Invoke_Property = "Strips"
    If blnDestroyed = True Then Strip.Top = -1
    StripsTop = Strip.Top
End Property

Public Property Let StripsTop(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Strip.Top = vNewValue
    PropertyChanged "StripsTop"
End Property

Public Property Get StripsWidth() As Long
Attribute StripsWidth.VB_Description = "Change the with rectangule strip."
Attribute StripsWidth.VB_ProcData.VB_Invoke_Property = "Strips"
    If blnDestroyed = True Then Strip.Width = -1
    StripsWidth = Strip.Width
End Property

Public Property Let StripsWidth(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Strip.Width = vNewValue
    PropertyChanged "StripsWidth"
End Property

Public Property Get StripsHeight() As Long
Attribute StripsHeight.VB_Description = "Change the height of rectangule strip."
Attribute StripsHeight.VB_ProcData.VB_Invoke_Property = "Strips"
    If blnDestroyed = True Then Strip.Height = -1
    StripsHeight = Strip.Height
End Property

Public Property Let StripsHeight(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Strip.Height = vNewValue
    PropertyChanged "StripsHeight"
End Property

Public Property Get StripsSeparationVertical() As Long
Attribute StripsSeparationVertical.VB_Description = "Change the vertical separation betwen the strips rectangules."
Attribute StripsSeparationVertical.VB_ProcData.VB_Invoke_Property = "Strips"
    If blnDestroyed = True Then Strip.SeparationVertical = -1
    StripsSeparationVertical = Strip.SeparationVertical
End Property

Public Property Let StripsSeparationVertical(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Strip.SeparationVertical = vNewValue
    PropertyChanged "StripsSeparationVertical"
End Property

Public Property Get StripsSeparationHorizontal() As Long
Attribute StripsSeparationHorizontal.VB_Description = "Change the horizontal separation betwen the strips rectangules."
Attribute StripsSeparationHorizontal.VB_ProcData.VB_Invoke_Property = "Strips"
    If blnDestroyed = True Then Strip.SeparationHorizontal = -1
    StripsSeparationHorizontal = Strip.SeparationHorizontal
End Property

Public Property Let StripsSeparationHorizontal(ByVal vNewValue As Long)
    If blnDestroyed = True Then Exit Property
    Strip.SeparationHorizontal = vNewValue
    PropertyChanged "StripsSeparationHorizontal"
End Property

Private Sub UpgradeSubimages()
    Dim i As Long
    Dim Y As Long
    Dim X As Long
    If shpSubImage.Count > 1 Then
        For i = 1 To shpSubImage.Count - 1
            Unload shpSubImage(i)
        Next i
    End If
    If PicAnimation.Count > 1 Then
        For i = 1 To PicAnimation.Count - 1
            Unload PicAnimation(i)
        Next i
    End If
    i = 1
    For Y = 1 To Strip.ImagesLine
        For X = 1 To Strip.ImagesColumn
            Load shpSubImage(i)
            shpSubImage(i).Visible = True
            shpSubImage(i).Left = Strip.Left + IFF(X > 1, (Strip.Width + Strip.SeparationHorizontal) * (X - 1), 0)
            shpSubImage(i).Top = Strip.Top + IFF(Y > 1, (Strip.Height + Strip.SeparationVertical) * (Y - 1), 0)
            shpSubImage(i).Height = Strip.Height
            shpSubImage(i).Width = Strip.Width
            i = i + 1
        Next X
    Next Y
    lngTotalSubImages = shpSubImage.Count - 1
    For X = 1 To lngTotalSubImages
        Load PicAnimation(X)
        PicAnimation(X).Picture = Nothing
        PicAnimation(X).Height = Strip.Height
        PicAnimation(X).Width = Strip.Width
        TransparentBlt PicAnimation(X).hdc, 0, 0, shpSubImage(X).Width, shpSubImage(X).Height, _
        PicAnimation(0).hdc, shpSubImage(X).Left, shpSubImage(X).Top, shpSubImage(X).Width, shpSubImage(X).Height, _
        GetPixel(PicAnimation(0).hdc, PicAnimation(0).Width - 1, PicAnimation(0).Height - 1)
    Next X
    UserControl.Height = Strip.Height * Screen.TwipsPerPixelX
    UserControl.Width = Strip.Width * Screen.TwipsPerPixelY
    UserControl.Cls
    UserControl.BackColor = PicAnimation(1).BackColor
    UserControl.Picture = PicAnimation(1).Image
    Call SubTransparent
    lngActualSubImage = 1
End Sub

Public Property Get ActivateJoystick() As Boolean
Attribute ActivateJoystick.VB_Description = "Activate and Desactivate the Joystick."
    If blnDestroyed = True Then blnJoystickActivate = False
    ActivateJoystick = blnJoystickActivate
End Property

Public Property Let ActivateJoystick(ByVal vNewValue As Boolean)
    If blnDestroyed = True Then Exit Property
    blnJoystickActivate = vNewValue
    If blnJoystickActivate = True Then tmrNewEvents.Enabled = Ambient.UserMode
    PropertyChanged "ActivateJoystick"
End Property

Public Property Get ActivateMoveNotMoveEvents() As Boolean
Attribute ActivateMoveNotMoveEvents.VB_Description = "Activate and Desactivate the Move and NotMove Events."
    If blnDestroyed = True Then blnActivateMoveNotMoveEvents = False
    ActivateMoveNotMoveEvents = blnActivateMoveNotMoveEvents
End Property

Public Property Let ActivateMoveNotMoveEvents(ByVal vNewValue As Boolean)
    If blnDestroyed = True Then Exit Property
    blnActivateMoveNotMoveEvents = vNewValue
    If blnActivateMoveNotMoveEvents = True Then tmrNewEvents.Enabled = True
    PropertyChanged "ActivateMoveNotMoveEvents"
End Property

Public Function Img() As StdPicture
    If blnDestroyed = True Then
        Set Img = Nothing
    Else
        Set Img = UserControl.Image
    End If
End Function

Public Property Get BlackAndWhite() As Boolean
    BlackAndWhite = blnBlackAndWhite
End Property

Public Property Let BlackAndWhite(newBlackAndWhite As Boolean)
    blnBlackAndWhite = newBlackAndWhite
    Call ShowImage
    PropertyChanged "BlackAndWhite"
End Property


Public Sub SaveImage(Folder As String)
    If blnDestroyed = True Then Exit Sub
    SavePicture UserControl.Image, Folder
End Sub

Public Property Get Transparent() As TransparentState
Attribute Transparent.VB_Description = "Put the image Transparent or not."
    Transparent = traTransparent
End Property

Public Property Let Transparent(ByVal vNewValue As TransparentState)
    traTransparent = vNewValue
    Call ShowImage
    PropertyChanged "Transparent"
End Property

Public Property Get Mirror() As MirrorStates
Attribute Mirror.VB_Description = "Do image mirror/flip."
    Mirror = meMirrorEffects
End Property

Public Property Let Mirror(ByVal vNewValue As MirrorStates)
    meMirrorEffects = vNewValue
    Call ShowImage
    PropertyChanged "Mirror"
End Property

Public Property Get Stretch() As Boolean
Attribute Stretch.VB_Description = "Stretch the image."
    Stretch = blnStretch
End Property

Public Property Let Stretch(newStretch As Boolean)
    blnStretch = newStretch
    Call ShowImage
    PropertyChanged "Stretch"
End Property

Public Property Get TransparentImage() As Boolean
    TransparentImage = blnTransparentImage
End Property

Public Property Let TransparentImage(newTransparentImage As Boolean)
    blnTransparentImage = newTransparentImage
    Call ShowImage
    PropertyChanged "TransparentImage"
End Property


Private Sub ShowImage()
    Dim X As Long
    Dim Y As Long
    Dim BF As Long
    Const USE_BITMAP_ALPHA = &H1000000 'AC_SRC_ALPHA scaled up to the 4th byte of a long
    On Error Resume Next
    If strFileName <> "" Then
        UserControl.Picture = Nothing
        UserControl.MaskPicture = Nothing
        UserControl.MaskColor = Empty
        If blnStretch = True Then
            StretchBlt UserControl.hdc, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, PicAnimation(lngActualSubImage).hdc, 0, 0, PicAnimation(lngActualSubImage).Width, PicAnimation(lngActualSubImage).Height, vbSrcCopy
        Else
            If blnAutoSize = True Then
                UserControl.Width = PicAnimation(lngActualSubImage).ScaleWidth * Screen.TwipsPerPixelX
                UserControl.Height = PicAnimation(lngActualSubImage).ScaleHeight * Screen.TwipsPerPixelY
            End If
            BitBlt UserControl.hdc, 0, 0, PicAnimation(lngActualSubImage).ScaleWidth, PicAnimation(lngActualSubImage).ScaleHeight, PicAnimation(lngActualSubImage).hdc, 0, 0, vbSrcCopy
        End If
        If lngRotate <> 0 Then
            Call RotateImage(picGraphicsEffects, PicAnimation(lngActualSubImage), lngRotate)
            If blnStretch = False Then
                If blnAutoSize = True Then
                    UserControl.Width = PicAnimation(lngActualSubImage).Width * Screen.TwipsPerPixelX
                    UserControl.Height = PicAnimation(lngActualSubImage).Height * Screen.TwipsPerPixelY
                End If
                BitBlt UserControl.hdc, 0, 0, PicAnimation(lngActualSubImage).Width, PicAnimation(lngActualSubImage).Height, picGraphicsEffects.hdc, 0, 0, vbSrcCopy
            Else
                StretchBlt UserControl.hdc, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, picGraphicsEffects.hdc, 0, 0, PicAnimation(lngActualSubImage).Width, PicAnimation(lngActualSubImage).Height, vbSrcCopy
            End If
        End If
        If OldColor <> NewColor Then
            picGraphicsEffects.Cls
            picGraphicsEffects.Picture = UserControl.Image
            ChangeColor picGraphicsEffects, lngOldColor, lngNewColor
            UserControl.Picture = picGraphicsEffects.Image
        End If
        If blnBlackAndWhite = True Then
            With UserControl
                GrayScale32 .hdc, .Image.handle, .ScaleWidth, .ScaleHeight
                UserControl.Picture = UserControl.Image
            End With
        End If
        If meMirrorEffects <> None Then Call MirrorEffects(meMirrorEffects)
        'these if is for be changed
        If blnTransparentImage = True Then
            'BF = 128 * &H10000  'semi transparent ignoring bitmaps alpha channel
            BF = 255 * &H10000 Or USE_BITMAP_ALPHA 'fully opaque using bitmaps alpha channel
            picGraphicsEffects.Picture = UserControl.Image
            AlphaBlend UserControl.hdc, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, picGraphicsEffects.hdc, 0, 0, picGraphicsEffects.ScaleWidth, picGraphicsEffects.ScaleHeight, BF
        End If
        If blnTiles = True Then
            picGraphicsEffects.Cls
            picGraphicsEffects.Width = IFF(Strip.Activate = True, PicAnimation(1).Width, PicAnimation(0).Width)
            picGraphicsEffects.Height = IFF(Strip.Activate = True, PicAnimation(1).Width, PicAnimation(0).Width)
            picGraphicsEffects.Picture = UserControl.Image
            For X = 0 To UserControl.Width Step PicAnimation(0).Width
                For Y = 0 To UserControl.Height Step PicAnimation(0).Height
                    BitBlt UserControl.hdc, X, Y, picGraphicsEffects.ScaleWidth, picGraphicsEffects.ScaleHeight, picGraphicsEffects.hdc, 0, 0, vbSrcCopy
                Next Y
            Next X
        End If
    ElseIf strFileName = "" Then
        picGraphicsEffects.Picture = UserControl.Image
        If IsPicture(picGraphicsEffects) <> True Then Exit Sub
        lngTotalSubImages = 1
        lngActualSubImage = 0
        UserControl.MaskPicture = Nothing
        UserControl.MaskColor = Empty
        If blnAutoSize = True Then
            UserControl.Width = UserControl.ScaleWidth * Screen.TwipsPerPixelX
            UserControl.Height = UserControl.ScaleHeight * Screen.TwipsPerPixelY
        End If
        If blnStretch = True Then
            picGraphicsEffects.Cls
            picGraphicsEffects.Width = UserControl.Width
            picGraphicsEffects.Height = UserControl.Height
            StretchBlt picGraphicsEffects.hdc, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, UserControl.hdc, 0, 0, UserControl.Width, UserControl.Height, vbSrcCopy
            UserControl.Picture = picGraphicsEffects.Image
        End If
        If lngRotate <> 0 Then
            picGraphicsEffects.Cls
            picGraphicsEffects.Picture = UserControl.Image
            PicAnimation(0).Cls
            PicAnimation(0).BackColor = GetPixel(UserControl.hdc, 0, 0)
            Call RotateImage(PicAnimation(0), picGraphicsEffects, lngRotate)
            UserControl.Picture = Nothing
            TransparentBlt UserControl.hdc, 0, 0, PicAnimation(0).ScaleWidth, PicAnimation(0).ScaleWidth, PicAnimation(0).hdc, 0, 0, PicAnimation(0).ScaleWidth, PicAnimation(0).ScaleHeight, GetPixel(PicAnimation(0).hdc, 0, 0)
            UserControl.Picture = UserControl.Image
        End If
        If meMirrorEffects <> None Then Call MirrorEffects(meMirrorEffects)
        'these if is for be changed
        If blnTransparentImage = True Then
            'BF = 128 * &H10000  'semi transparent ignoring bitmaps alpha channel
            BF = 255 * &H10000 Or USE_BITMAP_ALPHA 'fully opaque using bitmaps alpha channel
            picGraphicsEffects.Picture = UserControl.Image
            AlphaBlend UserControl.hdc, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, picGraphicsEffects.hdc, 0, 0, picGraphicsEffects.ScaleWidth, picGraphicsEffects.ScaleHeight, BF
        End If
        If blnBlackAndWhite = True Then
            With UserControl
                GrayScale32 .hdc, .Image.handle, .ScaleWidth, .ScaleHeight
            End With
        End If
    End If
    'the next line is need too... when the shadow is desactivated
    UserControl.Picture = UserControl.Image
    PicAnimation(0).Tag = ""
    Call SubTransparent
    RaiseEvent ChangeImage(lngActualSubImage)
End Sub

Private Sub MirrorEffects(Flip As MirrorStates)
    Dim PX As Long
    Dim PY As Long
    picGraphicsEffects.Cls
    PX = UserControl.ScaleWidth
    PY = UserControl.ScaleHeight
    picGraphicsEffects.Width = PX
    picGraphicsEffects.Height = PY
    If Flip = None Then
        Exit Sub
    ElseIf Flip = Horizontal Then
        StretchBlt picGraphicsEffects.hdc, PX, 0, -PX, PY, UserControl.hdc, 0, 0, PX, PY, vbSrcCopy
    ElseIf Flip = Vertical Then
        StretchBlt picGraphicsEffects.hdc, 0, PY, PX, -PY, UserControl.hdc, 0, 0, PX, PY, vbSrcCopy
    ElseIf Flip = VerticalHorizontal Then
        StretchBlt picGraphicsEffects.hdc, PX, PY, -PX, -PY, UserControl.hdc, 0, 0, PX, PY, vbSrcCopy
    End If
    UserControl.Picture = picGraphicsEffects.Image
End Sub

Public Property Get AutoSize() As Boolean
    AutoSize = blnAutoSize
End Property

Public Property Let AutoSize(ByVal vNewValue As Boolean)
    blnAutoSize = vNewValue
    Call ShowImage
    PropertyChanged "AutoSize"
End Property

Public Property Get Rotate() As Long
    Rotate = lngRotate
End Property

Public Property Let Rotate(newRotate As Long)
    lngRotate = newRotate
    Call ShowImage
    PropertyChanged "Rotate"
End Property

Public Property Get AutoRedraw() As Boolean
    AutoRedraw = UserControl.AutoRedraw
End Property

Public Property Let AutoRedraw(ByVal vNewValue As Boolean)
    UserControl.AutoRedraw = vNewValue
    PropertyChanged "AutoRedraw"
End Property

Public Property Get Tiles() As Boolean
    Tiles = blnTiles
End Property

Public Property Let Tiles(ByVal vNewValue As Boolean)
    blnTiles = vNewValue
    Call ShowImage
    PropertyChanged "Tiles"
End Property

Public Property Get OldColor() As OLE_COLOR
    OldColor = lngOldColor
End Property

Public Property Let OldColor(ByVal vNewValue As OLE_COLOR)
    lngOldColor = vNewValue
    Call ShowImage
    PropertyChanged "OldColor"
End Property

Public Property Get NewColor() As OLE_COLOR
    NewColor = lngNewColor
End Property

Public Property Let NewColor(ByVal vNewValue As OLE_COLOR)
    lngNewColor = vNewValue
    Call ShowImage
    PropertyChanged "NewColor"
End Property

Public Property Get HasDC() As Boolean
    HasDC = UserControl.HasDC
End Property

Public Property Get hdc() As Long
    hdc = UserControl.hdc
End Property

Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property
